import * as React from 'react'
import {reducerRegistry,subscribe,unsubscribe,store,isExternal} from 'redux-extra' 
import assign from 'lodash/assign'
import { routeActions } from '../router'

export default class BasePage extends React.Component {
    constructor(props) {
        super(props);
        this.subscriptions = [];
    }

    hashFnv(str, seed) {
        var i, l, hval = (seed === undefined) ? 0x811c9dc5 : seed;
        for (i = 0, l = str.length; i < l; i++) {
            hval ^= str.charCodeAt(i);
            hval += (hval << 1) + (hval << 4) + (hval << 7) + (hval << 8) + (hval << 24);
        }
        return ("0000000" + (hval >>> 0).toString(16)).substr(-8);
    }

    connect(cmpRef,pageReducers=null,initalobjectvalues=null) { 
        var reducertags = [];
        if(pageReducers) {  
            for(var i=0; i < pageReducers.length; i++) {
                var pageReducer = pageReducers[i];
                var newReducer = {};
				newReducer[this.hashFnv(pageReducer.toString())] = pageReducer;
                if(!isExternal) reducerRegistry.register(newReducer);
                for(var reducertag in newReducer) {
                    reducertags.push(reducertag);
                    var reducerkey = reducerRegistry.getIncrement();
                    this.subscriptions.push({path: reducertag, key: reducerkey}); 
                    subscribe(reducertag, reducerkey, (payload) => {
                        var currentState = store.getState();
		                cmpRef.setState(currentState[payload.path]);
                    });
                }
            }
        }
        var currentState = store.getState();
        var storeobjects = {};
        for (var commontag in reducerRegistry.getCommonReducers()) {
            if(commontag == 'context' || commontag == 'routing') {
                storeobjects[commontag] = currentState[commontag];
            } else {
                assign(storeobjects, currentState[commontag]);
            }
            var key = reducerRegistry.getIncrement();
            this.subscriptions.push({path: commontag, key: key});
            subscribe(commontag, key, (payload) => {
                var currentState = store.getState();
                if(payload.path  == 'context' || payload.path  == 'routing') {
                    var stateobj = {};
                    stateobj[payload.path] = currentState[payload.path];
                    cmpRef.setState(stateobj);
                } else {
                    cmpRef.setState(currentState[payload.path]);
                }
            });
        }
        for(var i=0; i < reducertags.length; i++) {
            assign(storeobjects, currentState[reducertags[i]]);
        }
        if(initalobjectvalues){
             assign(storeobjects, initalobjectvalues);
        }
        cmpRef.state={...storeobjects};
        assign(cmpRef, routeActions);
    }

    componentWillUnmount() { 
        if(this.subscriptions.length > 0) {
            for(var i=0; i < this.subscriptions.length; i++) {
                unsubscribe(this.subscriptions[i].path, this.subscriptions[i].key);
            }
        } 
    }
}